angular.module("kyee.framework.directive.picker.cascade_list_picker.impl.area_picker", ["kyee.framework.config"])
	.directive("kyeeAreaPickerDirective", ["KyeeFrameworkConfig", function(KyeeFrameworkConfig) {
		
		var def = {
			scope: {
				title : "@",

				//模式，可取值为：PCA，其中，P 代表省，C 代表城市，A 代表区/县
				mode : "@",
				onSelectFinash : "&",
				bind : "&"
			},
            templateUrl: KyeeFrameworkConfig.KYEE_FRAMEWORK_BASE_PATH + "js/directive/picker/cascade-list-picker/impl/area_picker/templates/picker.html",
            replace: true,
            restrict: "A",
			controller : ["$scope", function($scope){

				if($scope.title == undefined){
					$scope.title = "请选择地区";
				}
				if($scope.mode == undefined){
					$scope.mode = "PCA";
				}

				//分组标签
				$scope.group4Base = [];
				if($scope.mode.indexOf("P") != -1){
					$scope.group4Base.push({
						text : "省份"
					});
				}
				if($scope.mode.indexOf("C") != -1){
					$scope.group4Base.push({
						text : "城市"
					});
				}
				if($scope.mode.indexOf("A") != -1){
					$scope.group4Base.push({
						text : "区/县"
					});
				}

				//from cascadeList method
				$scope.bind4Base = function(params){

					$scope.show4Base = params.show;
					$scope.updateData4Base = params.updateData;
				};

				//from cascadeList method
				$scope.onChange4Base = function(params){

					if(params.groupIndex == 0){

						$scope.updateData4Base([{
							groupIndex : 1,
							items : CITY_DATA_4_CITY_PICKER.citys[params.item.value] == undefined ? [] : CITY_DATA_4_CITY_PICKER.citys[params.item.value]
						}]);
					}
					if(params.groupIndex == 1){

						$scope.updateData4Base([{
							groupIndex : 2,
							items : CITY_DATA_4_CITY_PICKER.areas[params.item.value] == undefined ? [] : CITY_DATA_4_CITY_PICKER.areas[params.item.value]
						}]);
					}
				};

				//from cascadeList method
				$scope.onFinash4Base = function(params){

					return $scope.onSelectFinash({
						params : params
					});
				};

				/**
				 * 显示
				 */
				$scope.show = function(defaultValue){

					//待加载的所在省份、所在市的编号
					//默认使用北京
					var groupValues = {
						"P" : "110000",
						"C" : "110100"
					};

					//如果用户指定默认值，则优先使用该值
					//用户指定值得格式为：{0:"10000",1:"10100",2:"10101"}，并且 model 为 PCA，则 0 = P，1 = C，2 = A（注意位置对应）
					if(defaultValue != undefined){

						for(var value in defaultValue){

							//取到对应的编码（注意位置对应）
							var code = $scope.mode.charAt(parseInt(value));
							groupValues[code] = defaultValue[value];
						}
					}

					//数据
					//默认选择北京
					$scope.data4Base = [];
					if($scope.mode.indexOf("P") != -1){
						$scope.data4Base.push({
							groupIndex : 0,
							items : CITY_DATA_4_CITY_PICKER.provinces
						});
					}
					if($scope.mode.indexOf("C") != -1){
						$scope.data4Base.push({
							groupIndex : 1,
							items : CITY_DATA_4_CITY_PICKER.citys[groupValues.P]
						});
					}
					if($scope.mode.indexOf("A") != -1){
						$scope.data4Base.push({
							groupIndex : 2,
							items : CITY_DATA_4_CITY_PICKER.areas[groupValues.C]
						});
					}

					$scope.show4Base(defaultValue);
				};

				$scope.bind({
					params : $scope
				});
			}]
        };

		return def;
	}]);