angular.module("kyee.framework.directive.picker.cascade_list_picker.impl.date_picker", ["kyee.framework.config"])
	.directive("kyeeDatePickerDirective", ["KyeeFrameworkConfig", "KyeeDatePickerService", function(KyeeFrameworkConfig, KyeeDatePickerService) {
		
		var def = {
			scope: {
				title : "@",
				//模式，可取值为：YMD，其中，Y 代表年，M 代表月，D 代表天
				mode : "@",
				yearRange : "@",
				onSelectFinash : "&",
				bind : "&"
			},
            templateUrl: KyeeFrameworkConfig.KYEE_FRAMEWORK_BASE_PATH + "js/directive/picker/cascade-list-picker/impl/date_picker/templates/picker.html",
            replace: true,
            restrict: "A",
			controller : ["$scope", function($scope){

				//保存当前的年份
				var currYear = 0;

				if($scope.title == undefined){
					$scope.title = "请选择日期";
				}
				if($scope.mode == undefined){
					$scope.mode = "YMD";
				}
				if($scope.yearRange == undefined){
					$scope.yearRange = "1949->";
				}

				//生成标签
				$scope.group4Base = [];
				if($scope.mode.indexOf("Y") != -1){
					$scope.group4Base.push({
						text : "年"
					});
				}
				if($scope.mode.indexOf("M") != -1){
					$scope.group4Base.push({
						text : "月"
					});
				}
				if($scope.mode.indexOf("D") != -1){
					$scope.group4Base.push({
						text : "日"
					});
				}

				//from cascadeList method
				$scope.bind4Base = function(params){

					$scope.show4Base = params.show;
					$scope.updateData4Base = params.updateData;
				};

				//from cascadeList method
				$scope.onChange4Base = function(params){
                    var year = moment().format("YYYY");
                    var yearPart = $scope.yearRange.trim().split("->");
                    var monflag = yearPart[0].split(",")[1];
					if(params.groupIndex == "0"){
                        //存储当前所选的年份
                        currYear = params.item.value;
                        if(!monflag){
                            return
						}else{
                            updateMonths();
                            var dayCount = KyeeDatePickerService.getDayCount(currYear, 1);
                            updateDay()
							}
					}else if(params.groupIndex == "1" && $scope.mode.indexOf("D") != -1){
						//更新当前月的天数
						var month = params.item.value;
						var currYear = params.selectedItems[0].value;
						if(!!monflag&&currYear == year&&month == new Date().getMonth()+1){
                            var dayCount = KyeeDatePickerService.getDayCount(currYear, month,monflag);
                            updateDay()
						}else{
                            var dayCount = KyeeDatePickerService.getDayCount(currYear, month);
                            updateDay()
						}
					}
					//更新月数
					function updateMonths(){
						var months = [];
						var end = !!monflag&&currYear == year?new Date().getMonth()+1:12;
                        for(var i = 1; i<=end; i++){
                            months.push({
                                text : i,
                                value : i
                            })
                        }

                        $scope.updateData4Base([
                            {
                                groupIndex : 1,
                                items : months
                            }
                        ]);
					}
					//更新天数
					function updateDay(){
                        var days = [];
                        for(var i = 1; i <= dayCount; i ++){
                            days.push({
                                text : i,
                                value : i
                            });
                        }

                        $scope.updateData4Base([
                            {
                                groupIndex : 2,
                                items : days
                            }
                        ]);
					}


                    if($scope.mode == "YMD" || $scope.mode == "YMDH"){
                        var a = new Array("日", "一", "二", "三", "四", "五", "六");
                        var d = new Date();
                        var selectedItems = params.selectedItems;
                        d.setFullYear(selectedItems["0"].value, selectedItems["1"].value - 1, selectedItems["2"].value);
                        $scope.title = "星期" + a[d.getDay()];
                    }
				};

				//from cascadeList method
				$scope.onFinash4Base = function(params){

					//生成时间序列化的值
					var fullDateString = "";
					var normalDateString = "";
					if($scope.mode.indexOf("D") != -1){
						normalDateString = params[0].value + "/" + params[1].value + "/" + params[2].value;
						fullDateString = params[0].value + "/" + (params[1].value < 10 ? "0" + params[1].value : params[1].value) + "/" + (params[2].value < 10 ? "0" + params[2].value : params[2].value)
					}else if($scope.mode.indexOf("M") != -1){
						normalDateString = params[0].value + "/" + params[1].value;
						fullDateString = params[0].value + "/" + (params[1].value < 10 ? "0" + params[1].value : params[1].value);
					}else{
                        normalDateString = params[0].value;
                        fullDateString = params[0].value;
					}

					params.normalDateString = normalDateString;
					params.fullDateString = fullDateString;

					return $scope.onSelectFinash({
						params : params
					});
				};

				/**
				 * 显示
				 */
				$scope.show = function(defaultValue){

					$scope.data4Base = [];

					//生成年份
					var years = [];
					var yearPart = $scope.yearRange.trim().split("->");
					var start = parseInt(yearPart[0].split(",")[0]);
					var end = yearPart.length == 1 || yearPart[1] == "" ? new Date().getFullYear() : parseInt(yearPart[1]);
					for(var i = start; i <= end; i ++){

						years.push({
							text : i,
							value : i
						});

                        }


					//生成月份
					var months = [];
                    var monflag = yearPart[0].split(",")[1];
                    var year = moment().format("YYYY");
                    var end = !!monflag? new Date().getMonth()+1:12;
					for(var i = 1; i <= end; i ++){
						months.push({
							text : i,
							value : i
						});
					}

					var dayCount = 0;
					if(defaultValue == undefined){

						//保存当前年份
						currYear = new Date().getFullYear();

						//生成默认值
						if($scope.mode.indexOf("D") != -1){

							//如果没有设置默认值，则默认显示当前日期
							defaultValue = {
								"0" : new Date().getFullYear(),
								"1" : new Date().getMonth() + 1,
								"2" : new Date().getDate()
							};

							dayCount = KyeeDatePickerService.getDayCount(new Date().getFullYear(), new Date().getMonth() + 1,monflag);
						}else{

							//如果没有设置默认值，则默认显示当前日期
							defaultValue = {
								"0" : new Date().getFullYear(),
								"1" : new Date().getMonth() + 1
							};
						}
					}else{

						//保存当前年份
						currYear = defaultValue["0"];
						dayCount = KyeeDatePickerService.getDayCount(defaultValue["0"], defaultValue["1"]);
					}

					//生成天
					var days = [];
					for(var i = 1; i <= dayCount; i ++){
						days.push({
							text : i,
							value : i
						});
					}

					//生成最终数据
					var dataset = [];
					if($scope.mode.indexOf("Y") != -1){
						dataset.push({
							groupIndex : "0",
							items : years
						});
					}
					if($scope.mode.indexOf("M") != -1){
						dataset.push({
							groupIndex : "1",
							items : months
						});
					}
					if($scope.mode.indexOf("D") != -1){
						dataset.push({
							groupIndex : "2",
							items : days
						});
					}
					$scope.data4Base = dataset;

                    if($scope.mode == "YMD" || $scope.mode == "YMDH"){
                        var a = new Array("日", "一", "二", "三", "四", "五", "六");
                        var d = new Date();
                        d.setFullYear(defaultValue[0], defaultValue[1] - 1, defaultValue[2]);
                        $scope.title = "星期" + a[d.getDay()];
                    }

					$scope.show4Base(defaultValue);
				};

				$scope.bind({
					params : $scope
				});
			}]
        };

		return def;
	}]);