angular.module("kyee.framework.directive.picker.list_picker", ["kyee.framework.config"])
	.directive("kyeeListPickerDirective", ["KyeeFrameworkConfig", "KyeeListPickerService", "$ionicScrollDelegate", "KyeeMessageService", "KyeeUtilsService", function(KyeeFrameworkConfig, KyeeListPickerService, $ionicScrollDelegate, KyeeMessageService, KyeeUtilsService) {
		
		var def = {
			scope: {
				title : "@",
				cancelText : "@",
				okText : "@",
				height : "@",
				type : "@",
				data : "=",
				selectFinash : "&",
				showSelectBtn : "@",
				bind : "&"
			},
            templateUrl: KyeeFrameworkConfig.KYEE_FRAMEWORK_BASE_PATH + "js/directive/picker/list_picker/templates/picker.html",
            replace: true,
            restrict: "A",
			controller : ["$scope", function($scope){

				//生成唯一标示符
				$scope.id = "picker_" + new Date().getTime();

				//存储当前所选值
				$scope.kyee_framework_picker = {
					radioChoose : null
				};

				//设置默认值
				if($scope.title == undefined){
					$scope.title = "请选择";
				}
				if($scope.cancelText == undefined){
					$scope.cancelText = "取消";
				}
				if($scope.okText == undefined){
					$scope.okText = "选择";
				}
				if($scope.height == undefined){
					$scope.height = 300;
				}
				if($scope.type == undefined){
					$scope.type = "radio";
				}

				if($scope.showSelectBtn == undefined){
                    $scope.showSelectBtn = "Y";
				}

				/**
				 * 显示选择器
				 */
				$scope.show = function(defaultValue){

					//设置默认值
					if($scope.type == "radio" && defaultValue != undefined){
						//延迟设置，以避免无法设置的问题
						KyeeUtilsService.delay({
							time : 200,
							action : function(){
								$scope.kyee_framework_picker.radioChoose = defaultValue;
							}
						});
					}

					//将内容容器滚动到顶部
					$ionicScrollDelegate.$getByHandle("kyee_framework_picker_content").scrollTop();
					KyeeListPickerService.showPickerDom($scope.id);
				};

				/**
				 * 选择完成
				 *
				 * @param type
				 * @param item
				 */
				$scope.finash = function(type){

					var me = this;

					if(type == "radio"){

						var value = $scope.kyee_framework_picker.radioChoose;
						if(value == null){

							KyeeMessageService.broadcast({
								content : "请选择一项"
							});
							return;
						}

						$scope.selectFinash({
							params : {
								item : KyeeListPickerService.getItemByValue($scope.data, value)
							}
						});
					}

					me.cancel();
				},

				/**
				 * 取消
				 */
				$scope.cancel = function(){

					var me = this;

					//清空本次所选择的值
					$scope.kyee_framework_picker.radioChoose = null;

					KyeeListPickerService.hidePickerDom($scope.id);
				};

				$scope.bind({
					params : $scope
				});
			}]
        };

		return def;
	}]);