new KyeeModule()
    .group("kyee.framework.directive.picker.list_picker.service")
    .type("service")
    .name("KyeeListPickerService")
    .action(function(){

        var def = {

            /**
             * 根据值获取条目
             *
             * @param data
             * @param value
             * @returns {*}
             */
            getItemByValue : function(data, value){

                for(var i in data){

                    var item = data[i];
                    if(item.value == value){
                        return item;
                    }
                }

                return null;
            },

            /**
             * 显示选择器
             *
             * @param id
             */
            showPickerDom : function(id){

                var picker = angular.element(document.getElementById(id));
                var backdrop = angular.element(document.getElementById(id + "_backdrop"));

                picker.removeClass("kyee-framework-picker-down");
                picker.css("display", "block");
                picker.addClass("kyee-framework-picker-up");

                backdrop.removeClass("kyee-framework-picker-backdrop-up");
                backdrop.removeClass("kyee-framework-picker-backdrop-down");
                backdrop.css("opacity", 0.7);

                //picker 运行到 250ms 后开始 backdrop 动画
                setTimeout(function(){
                    backdrop.css("display", "block");
                    picker.css("display", "block");
                    backdrop.addClass("kyee-framework-picker-backdrop-up");
                }, 250);
            },

            /**
             * 隐藏选择器
             *
             * @param id
             */
            hidePickerDom : function(id){

                var picker = angular.element(document.getElementById(id));
                var backdrop = angular.element(document.getElementById(id + "_backdrop"));

                picker.removeClass("kyee-framework-picker-up");
                picker.addClass("kyee-framework-picker-down");

                backdrop.removeClass("kyee-framework-picker-backdrop-up");
                backdrop.css("opacity", 0);
                backdrop.addClass("kyee-framework-picker-backdrop-down");

                //150ms 后 backdrop 隐藏
                setTimeout(function(){
                    backdrop.css("display", "none");
                }, 350);

                //200ms 后 picker 隐藏
                setTimeout(function(){
                    picker.css("display", "none");
                }, 400);
            }
        };

        return def;
    })
    .build();