angular.module("kyee.framework.directive.slidebox.slidebox_image", ["ionic", "kyee.framework.config"])
	.directive("kyeeSlideboxImageDirective", ["$ionicScrollDelegate", "$location", "KyeeFrameworkConfig", function($ionicScrollDelegate, $location, KyeeFrameworkConfig) {
		
		var def = {
			scope: {
				images : "=",
				speed : "@",
				itemclick : "&",
				bind : "&"
			},
            templateUrl: KyeeFrameworkConfig.KYEE_FRAMEWORK_BASE_PATH + "js/directive/slidebox/slidebox_image/templates/slidebox_image.html",
            replace: true,
            restrict: "A",
			controller : ["$scope", function($scope){

				//初始化滚动速度
				if($scope.speed == undefined){
					$scope.speed = 5000;
				}

				//开启定时器
				var currImgIdx = 1;//下一个开始的图片为第 2 个
				var pImgIdx = 0;
				var isContinue = true;
				setInterval(function(){

					if(!isContinue){
						return;
					}

					$location.hash("kyee_framework_slidebox_image_anchor_" + currImgIdx);
					$ionicScrollDelegate.$getByHandle("kyee_framework_slidebox_image").anchorScroll(true);

					if(currImgIdx >= $scope.images.length - 1){
						pImgIdx = $scope.images.length - 1;
						currImgIdx = 0;
					}else{
						pImgIdx = currImgIdx;
						currImgIdx ++;
					}

				}, $scope.speed);

				/**
				 * 更新
				 */
				$scope.update = function(){

					$ionicScrollDelegate.$getByHandle("kyee_framework_slidebox_image").scrollTop();
				};

				/**
				 * 播放
				 */
				$scope.play = function(){

					isContinue = true;
				};

				/**
				 * 停止播放
				 */
				$scope.stop = function(){

					isContinue = false;
				};

				/**
				 * 图片单击时
				 *
				 * @param item
				 */
				$scope.onImageClick = function(item){

					$scope.itemclick({
						params : {
							item : item
						}
					});
				};

				/**
				 * 作用域绑定
				 */
				$scope.bind({
					params : $scope
				});
			}]
        };
		
		return def;
	}]);