angular.module("kyee.framework.directive.view.overlay", ["kyee.framework.config"])
	.directive("kyeeOverlayDirective", ["KyeeFrameworkConfig", function(KyeeFrameworkConfig) {

		var def = {
			scope: {
				bind : "&",
				template : "@"
			},
            templateUrl: KyeeFrameworkConfig.KYEE_FRAMEWORK_BASE_PATH + "js/directive/view/overlay/templates/overlay.html",
            replace: true,
            restrict: "A",
			init : function(){

				var me = this;

				//生成唯一标示符
				def.innerScope.id = "overlay_" + new Date().getTime();

				/**
				 * 执行绑定方法
				 */
				def.innerScope.bind({
					params : def.methods.outer
				});

				for(var i in def.methods.inner){
					def.innerScope[i] = def.methods.inner[i];
				}
			},
			controller : ["$scope", function($scope){

				def.innerScope = $scope;
			}],
			link : function(scope, element, attrs){

				def.element = element;
				def.attrs = attrs;

				def.init();
			},
			methods : {

				//外部方法
				outer : {

					show : function(){

						document.getElementById(def.innerScope.id).style.display = "block";
					}
				},

				//内部方法
				inner : {

					hide : function(){

						document.getElementById(def.innerScope.id).style.display = "none";
					}
				}
			}
        };

		return def;
	}]);