﻿
angular.module('kyee.framework.service.mtrlversion',
    ['kyee.mobileoffice.service_bus.http'])
    .factory('mtrlVersionService',
        ['HttpServiceBus', function (HttpServiceBus) {
            var mtrlVersion = '';
            (function () {
                HttpServiceBus.doConnect({
                    url: '/appServices/appService.next',
                    params: {
                        OP_NAME: "MTRL_QUERY_VERSION",
                        PARAMS: {}
                    },
                    onSuccess: function (resp) {
                        if (!resp || !resp.success) {
                            return;
                        }
                        mtrlVersion = resp.data;
                    }
                });
            })();

            function getSeparator() {
                // 物资版本旧时，使用"|"作为分隔符
                if (mtrlVersion < '20180601') {
                    return '|'
                }
                // 物资版本新时，使用"~~"作为分隔符
                return '~~';
            }

            return {
                getSeparator: getSeparator

            }
        }]);